'UNLZEXE 0.8
'ported to BlitzMax by K1n9_Duk3

SuperStrict

Const SUCCESS:Byte = 0
Const FAILURE:Byte = 1

Private

Const tmpfname$ = "$tmpfil$.exe"
Const backup_ext$ = ".olz"

Global ihead:Short[$10], ohead:Short[$10], inf:Short[8]
'Global allocsize:Short
Global loadsize:Int

' these should be arrays of bytes, but that doesn't work in BlitzMax
Global sig90:Int[] = [$06, $0E, $1F, $8B, $0E, $0C, $00, $8B, $F1, $4E, $89, $F7, $8C, $DB, $03, $1E, $0A, $00, $8E, $C3, $B4, $00, $31, $ED, $FD, $AC, $01, $C5, $AA, $E2, $FA, $8B, $16, $0E, $00, $8A, $C2, $29, $C5, $8A, $C6, $29, $C5, $39, $D5, $74, $0C, $BA, $91, $01, $B4, $09, $CD, $21, $B8, $FF, $4C, $CD, $21, $53, $B8, $53, $00, $50, $CB, $2E, $8B, $2E, $08, $00, $8C, $DA, $89, $E8, $3D, $00, $10, $76, $03, $B8, $00, $10, $29, $C5, $29, $C2, $29, $C3, $8E, $DA, $8E, $C3, $B1, $03, $D3, $E0, $89, $C1, $D1, $E0, $48, $48, $8B, $F0, $8B, $F8, $F3, $A5, $09, $ED, $75, $D8, $FC, $8E, $C2, $8E, $DB, $31, $F6, $31, $FF, $BA, $10, $00, $AD, $89, $C5, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $73, $03, $A4, $EB, $F1, $31, $C9, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $72, $22, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $D1, $D1, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $D1, $D1, $41, $41, $AC, $B7, $FF, $8A, $D8, $E9, $13, $00, $AD, $8B, $D8, $B1, $03, $D2, $EF, $80, $CF, $E0, $80, $E4, $07, $74, $0C, $88, $E1, $41, $41, $26, $8A, $01, $AA, $E2, $FA, $EB, $A6, $AC, $08, $C0, $74, $40, $3C, $01, $74, $05, $88, $C1, $41, $EB, $EA, $89]
Global sig91:Int[] = [$06, $0E, $1F, $8B, $0E, $0C, $00, $8B, $F1, $4E, $89, $F7, $8C, $DB, $03, $1E, $0A, $00, $8E, $C3, $FD, $F3, $A4, $53, $B8, $2B, $00, $50, $CB, $2E, $8B, $2E, $08, $00, $8C, $DA, $89, $E8, $3D, $00, $10, $76, $03, $B8, $00, $10, $29, $C5, $29, $C2, $29, $C3, $8E, $DA, $8E, $C3, $B1, $03, $D3, $E0, $89, $C1, $D1, $E0, $48, $48, $8B, $F0, $8B, $F8, $F3, $A5, $09, $ED, $75, $D8, $FC, $8E, $C2, $8E, $DB, $31, $F6, $31, $FF, $BA, $10, $00, $AD, $89, $C5, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $73, $03, $A4, $EB, $F1, $31, $C9, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $72, $22, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $D1, $D1, $D1, $ED, $4A, $75, $05, $AD, $89, $C5, $B2, $10, $D1, $D1, $41, $41, $AC, $B7, $FF, $8A, $D8, $E9, $13, $00, $AD, $8B, $D8, $B1, $03, $D2, $EF, $80, $CF, $E0, $80, $E4, $07, $74, $0C, $88, $E1, $41, $41, $26, $8A, $01, $AA, $E2, $FA, $EB, $A6, $AC, $08, $C0, $74, $34, $3C, $01, $74, $05, $88, $C1, $41, $EB, $EA, $89, $FB, $83, $E7, $0F, $81, $C7, $00, $20, $B1, $04, $D3, $EB, $8C, $C0, $01, $D8, $2D, $00, $02, $8E, $C0, $89, $F3, $83, $E6, $0F, $D3, $EB, $8C, $D8, $01, $D8, $8E, $D8, $E9, $72]

' EXE header test (is it LZEXE file?)
Function rdhead:Byte(ifile:TStream, ver:Int Var)
	For Local i:Int = 0 Until $10
		ihead[i] = ReadShort(ifile)
		ohead[i] = ihead[i]
	Next
	If ((ihead[0]<>$5a4d And ihead[0]<>$4d5a) Or ihead[$d]<>0 Or ihead[$c]<>$1c)
		Return FAILURE
	EndIf
	Local entry:Int = ((ihead[4] + ihead[$b]) Shl 4) + ihead[$a]
	If SeekStream(ifile, entry) <> entry Then Return FAILURE
	If Eof(ifile) Or StreamPos(ifile) > StreamSize(ifile) Then Return FAILURE
	Local is90:Byte = True, is91:Byte = True
	For Local i:Byte = 0 Until sig90.length
		Local b:Byte = ReadByte(ifile)
		is90 :& b = sig90[i]
		is91 :& b = sig91[i]
	Next
	If is90
		ver = 90
		Return SUCCESS
	ElseIf is91
		ver = 91
		Return SUCCESS
	EndIf
	Rem
	If ihead[$c]=$1c And (ihead[$e]=$5A4C And ihead[$f]=$3930) '= "LZ09"
		ver = 90
		Return SUCCESS
	EndIf
	If ihead[$c]=$1c And (ihead[$e]=$5A4C And ihead[$f]=$3139) '= "LZ91"
		ver = 91
		Return SUCCESS
	EndIf
	EndRem
	Return FAILURE
EndFunction

' make relocation table
Function mkreltbl:Byte(ifile:TStream, ofile:TStream, ver:Int)
	Local i:Int, fpos:Long
	
	'allocsize = ((ihead[1]+16-1) Shr 4) + ((ihead[2]-1) Shl 5) - ihead[4] + ihead[5]
	fpos = (ihead[$b]+ihead[4]) Shl 4
	If SeekStream(ifile, fpos) <> fpos	' goto CS:0000
		Return FAILURE
	EndIf
	For Local n:Int = 0 Until 8
		inf[n] = ReadShort(ifile)
	Next
	ohead[$a] = inf[0]	' IP
	ohead[$b] = inf[1]	' CS
	ohead[$8] = inf[2]	' SP
	ohead[$7] = inf[3]	' SS
	Rem
		/* inf[4]:size of compressed Load Module (PARAGRAPH)*/
		/* inf[5]:increase of Load Module size (PARAGRAPH)*/
		/* inf[6]:size of decompressor with  compressed relocation table (Byte) */
		/* inf[7]:check sum of decompresser with compressd relocation table(Ver.0.90) */	
	EndRem
	ohead[$c] = $1c
	If SeekStream(ofile, $1c) <> $1c
'		Print "seek error"
		Return FAILURE
	EndIf
	Select ver
	Case 90
		i = reloc90(ifile, ofile, fpos)
	Case 91
		i = reloc91(ifile, ofile, fpos)
	Default
		i = FAILURE
	EndSelect
	If i<>SUCCESS
'		Print "error at relocation table."
		Return FAILURE
	EndIf
	fpos = StreamPos(ofile)
	If fpos = -1
		Return FAILURE
	EndIf
	i = ($200 - Short(fpos)) & $1FF
	'If i Then i = $200-i
	ohead[4] = (fpos+i) Shr 4
	
	While i > 0
		WriteByte(ofile, 0)
		i :- 1
	Wend
	Return SUCCESS
EndFunction

' for LZEXE ver 0.90
Function reloc90:Byte(ifile:TStream, ofile:TStream, fpos:Long)
	Local c:Int, rel_count:Short=0, rel_seg:Short, rel_off:Short
	
	If SeekStream(ifile, fpos+$19d) <> fpos+$19d
		Return FAILURE
	EndIf
	
	rel_seg = 0
	Repeat
		If Eof(ifile) Then Return FAILURE
		c = ReadShort(ifile)
		While c>0
			rel_off = ReadShort(ifile)
			WriteShort(ofile, rel_off)
			WriteShort(ofile, rel_seg)
			rel_count :+ 1
			c :- 1
		Wend
		rel_seg :+ $1000
	Until rel_seg = 0
	ohead[3]=rel_count
	Return SUCCESS
EndFunction

' for LZEXE ver 0.91
Function reloc91:Byte(ifile:TStream, ofile:TStream, fpos:Long)
	Local span:Short, rel_count:Short=0, rel_seg:Short, rel_off:Short
	
	If SeekStream(ifile, fpos+$158) <> fpos+$158
		Return FAILURE
	EndIf
	
	rel_off = 0
	rel_seg = 0
	Repeat
		If Eof(ifile) Then Return FAILURE
		span = ReadByte(ifile)
		If span = 0
			span = ReadShort(ifile)
			If span = 0
				rel_seg :+ $FFF
				Continue
			ElseIf span = 1
				Exit
			EndIf
		EndIf
		rel_off :+ span
		rel_seg :+ (rel_off & (-1 ~ $f)) Shr 4
		rel_off :& $f
		WriteShort(ofile, rel_off)
		WriteShort(ofile, rel_seg)
		rel_count :+ 1
	Forever
	ohead[3] = rel_count
	Return SUCCESS
EndFunction

Type TBitstream
	Field fp:TStream, buf:Short, count:Byte

	Method GetBit:Byte()
		Local b:Byte = buf & 1
		count :- 1
		If count = 0
			buf = ReadShort(fp)
			count = $10
		Else
			buf = buf Shr 1
		EndIf
		
		Return b
	EndMethod
EndType

Function initbits:TBitstream(filep:TStream)
	Local p:TBitstream = New TBitstream
	p.fp = filep
	p.Count = $10
	p.buf = ReadShort(filep)
	Return p
EndFunction

' decompressor routine
Function unpack:Byte(ifile:TStream, ofile:TStream)
	Local _len:Int, span:Int, fpos:Long
	Local bits:TBitstream
	Local data:Byte[$4500], p:Int=0
	
	fpos = (ihead[$b]-inf[4]+ihead[4]) Shl 4
	If SeekStream(ifile, fpos) <> fpos
		Return FAILURE
	EndIf
	fpos = ohead[4] Shl 4
	If SeekStream(ofile, fpos) <> fpos
		Return FAILURE
	EndIf
	bits = initbits(ifile)
'	WriteString(StandardIOStream, " unpacking. ")
'	StandardIOStream.Flush()
	
	Repeat
		If p>$4000
			For Local i:Int = 0 Until $2000
				WriteByte(ofile, data[i])
			Next
			p :- $2000
			For Local i:Int = 0 Until p
				data[i] = data[i+$2000]
			Next
'			WriteString(StandardIOStream, ".")
'			StandardIOStream.Flush()
		EndIf
		If bits.GetBit()
			data[p] = ReadByte(ifile)
			p :+ 1
			Continue
		EndIf
		If Not bits.GetBit()
			_len = bits.GetBit() Shl 1
			_len :| bits.GetBit()
			_len :+ 2
			span = ReadByte(ifile) | $FF00
		Else
			span = ReadByte(ifile)
			_len = ReadByte(ifile)
			span :| ((_len & (-1 ~ $07)) Shl 5) | $E000
			_len = (_len & $07)+2
			If _len = 2
				_len = ReadByte(ifile)
				
				If _len = 0
					Exit
				EndIf
				If _len = 1
					Continue
				Else
					_len :+ 1
				EndIf
			EndIf
		EndIf
		While _len > 0
			data[p] = data[Short(p+span)]
			p :+ 1
			_len :- 1
		Wend
	Forever
	If p<>0
		For Local i:Int = 0 Until p
			WriteByte(ofile, data[i])
		Next
	EndIf
	loadsize = StreamPos(ofile)-fpos
'	Print "end"
	Return SUCCESS
EndFunction

' write EXE header
Function wrhead(ofile:TStream)
	If ihead[6]<>0
		ohead[5] :- inf[5] + Short((inf[6]+16-1) Shr 4) +9
		If ihead[6]<>$FFFF
			ohead[6] :- (ihead[5]-ohead[5])
		EndIf
	EndIf
	ohead[1]=(loadsize+(ohead[4] Shl 4)) & $1ff
	ohead[2]=(loadsize+(ohead[4] Shl 4)+$1ff) Shr 9
	SeekStream(ofile, 0)
	For Local i:Int = 0 Until $e
		WriteShort(ofile, ohead[i])
	Next
EndFunction

Public

Function UnLZEXE:Byte(infile:Object, outfile:Object)
	Local ifile:TStream, ofile:TStream
	Local ver:Int
	
	ifile = ReadFile(infile)
	If Not ifile
		Return FAILURE
	EndIf
	If rdhead(ifile, ver)<>SUCCESS
'		Print "Not LZEXE compressed!"
		Return FAILURE
	EndIf
'	ofile = CreateMemoryStream($FFFFF)
	ofile = WriteFile(outfile)
	If Not ofile
		CloseFile(ifile)
		Return FAILURE
	EndIf
'	WriteString(StandardIOStream, "file is compressed by LZEXE Ver. ")
'	Select ver
'	Case 90
'		Print "0.90"
'	Case 91
'		Print "0.91"
'	EndSelect
	If mkreltbl(ifile, ofile, ver) <> SUCCESS
		CloseFile(ifile)
		CloseFile(ofile)
'		DeleteFile(outfile)
		Return FAILURE
	EndIf
	If unpack(ifile, ofile) <> SUCCESS
		CloseFile(ifile)
		CloseFile(ofile)
'		DeleteFile(outfile)
		Return FAILURE
	EndIf
	CloseFile(ifile)
	wrhead(ofile)
'	Print "outfile is :"+StreamSize(ofile)
	CloseFile(ofile)
	Return SUCCESS
EndFunction
